<?php

/**
 * @file smartqueue_users.views.inc
 * Smartqueue per User's Views integration.
 */


/**
 * Implementation of hook_views_handlers().
 */
function smartqueue_users_views_handlers() {
  return array(
    'info' => array(
      'path' => drupal_get_path('module', 'smartqueue_users') . '/includes/views',
    ),
    'handlers' => array(
      'smartqueue_users_handler_field_privacy' => array(
        'parent' => 'views_handler_field',
      ),
      'smartqueue_users_handler_filter_privacy' => array(
        'parent' => 'views_handler_filter',
      ),
    ),
  );
}

/**
 * Implementation of hook_views_data().
 */
function smartqueue_users_views_data() {
  $data = array();
  
  $data['smartqueue_users_subqueue']['table'] = array(
    'group' => t('Smartqueue per User'),
    'join' => array(
      'nodequeue_nodes' => array(
        'left_field' => 'sqid',
        'field' => 'sqid',
      ),
    ),
  );
  
  $data['smartqueue_users_subqueue']['sqid'] = array(
    'title' => 'sqid',
    'help' => t('The ID of the user subqueue.'),
  );
  
  $data['smartqueue_users_subqueue']['privacy'] = array(
    'title' => t('Subqueue privacy'),
    'help' => t('The privacy setting for a user subqueue.'),
    'field' => array(
      'handler' => 'smartqueue_users_handler_field_privacy',
      'additional fields' => array(
        '__smartqueue_users__queue_qid' => array(
          'table' => 'nodequeue_queue',
          'field' => 'qid',
        ),
        '__smartqueue_users__queue_owner' => array(
          'table' => 'nodequeue_queue',
          'field' => 'owner',
        ),
      ),
    ),
    /* TODO - Complete this filter, this is going to be tough
    'filter' => array(
      'handler' => 'smartqueue_users_handler_filter_privacy',
    ),
    */
  );
  
  return $data;
}
